"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CoverageBasedSex(ProtocolElement):
    """
    Coverage-based sex ======================================== General
    information about the checks, versions, tools, and number of
    markers TODO: Consider removing Inferred karyotype
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "inferredKaryotype": metrics_1_2_3.KaryotypicSex,
            "reviewedKaryotype": metrics_1_2_3.KaryotypicSex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "org.gel.models.metrics.avro.KaryotypicSex": metrics_1_2_3.KaryotypicSex,
            "org.gel.models.metrics.avro.KaryotypicSex": metrics_1_2_3.KaryotypicSex,
            "org.gel.models.metrics.avro.CoverageBasedSex": metrics_1_2_3.CoverageBasedSex,
        }

    __slots__ = [
        "avgCnvChrX",
        "avgCnvChrY",
        "inferredKaryotype",
        "ratioChrX",
        "ratioChrY",
        "reviewedKaryotype",
        "sampleId",
    ]

    def __init__(
        self,
        avgCnvChrX=None,
        avgCnvChrY=None,
        inferredKaryotype=None,
        ratioChrX=None,
        ratioChrY=None,
        reviewedKaryotype=None,
        sampleId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_3.CoverageBasedSex model.

        :param avgCnvChrX:
            Number of copies of chromosome X
        :type avgCnvChrX: None | double
        :param avgCnvChrY:
            Number of copies of chromosome Y
        :type avgCnvChrY: None | double
        :param inferredKaryotype:
            Inferred karyotype using coverage information
        :type inferredKaryotype: None | KaryotypicSex
        :param ratioChrX:
            Ratio of the average coverage of chromosome X to the average of the
            autosomal chromosome coverage
        :type ratioChrX: None | double
        :param ratioChrY:
            Ratio of the average coverage of chromosome Y to the average of the
            autosomal chromosome coverage
        :type ratioChrY: None | double
        :param reviewedKaryotype:
            Reviewed sex karyotype
        :type reviewedKaryotype: None | KaryotypicSex
        :param sampleId:
            Sample Id (e.g, LP00012645_5GH))
        :type sampleId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.3"
